'''
Created on Apr 10, 2018

@author: jessica
'''
from datalog.Predicate import Predicate

class Atom(object):

    def __init__(self):
        pass
    
    def __str__(self):
        return ""
    
    def getTerms(self):
        return []
    
    def getVariables(self):
        variables = set()
        for term in self.getTerms():
            v = term.getVariables()
            for var in v:
                variables.add(var)
        return variables
    
class ClassicalAtom(Atom):
 
    def __init__(self, predicate, terms, stronglyNegated = False):
        Atom.__init__(self)
        self.__predicate = predicate
        self.__terms = terms
        self.__stronglyNegated = stronglyNegated
    
    def __str__(self):
        s = self.__predicate.__str__()
        if len(self.__terms) > 0:
            s += "("
            for term in self.__terms:
                s += term.__str__() + ","
            s = s[:-1]
            s += ")"
        return s

    def isStronglyNegated(self):
        return self.__stronglyNegated


    def getPredicate(self):
        return self.__predicate


    def getTerms(self):
        return self.__terms


    def setStronglyNegated(self, value):
        self.__stronglyNegated = value


    def setPredicate(self, value):
        self.__predicate = value


    def setTerms(self, value):
        self.__terms = value

class BuiltInAtom(Atom):

    def __init__(self, terms, binaryOperation):
        Atom.__init__(self)
        self.__firstTerm = terms[0]
        self.__secondTerm = terms[1]
        self.__binaryOperation = binaryOperation
    
    def __str__(self):
        return self.__firstTerm.__str__() + self.__binaryOperation.__str__() + self.__secondTerm.__str__()
    
    def getTerms(self):
        return [self.__firstTerm, self.__secondTerm]
    
    def getFirstTerm(self):
        return self.__firstTerm


    def getSecondTerm(self):
        return self.__secondTerm


    def getBinaryOperation(self):
        return self.__binaryOperation


    def setFirstTerm(self, value):
        self.__firstTerm = value


    def setSecondTerm(self, value):
        self.__secondTerm = value


    def setBinaryOperation(self, value):
        self.__binaryOperation = value
