'''
Created on Apr 10, 2018

@author: jessica
'''
from datalog.Atom import Atom, ClassicalAtom
from datalog.Predicate import Predicate

class Literal(Atom):
    
    def __init__(self, negatedAsFailure = False):
        Atom.__init__(self)
        self.__negatedAsFailure = negatedAsFailure
    
    def __str__(self):
        if self.__negatedAsFailure:
            return "not " + Atom.__str__(self)
        return Atom.__str__(self)
    
    def getNegatedAsFailure(self):
        return self.__negatedAsFailure


    def setNegatedAsFailure(self, value):
        self.__negatedAsFailure = value
        
class NafLiteral(ClassicalAtom, Literal):
    
    def __init__(self, predicate, terms, stronglyNegated = False, negatedAsFailure = False):
        ClassicalAtom.__init__(self, predicate, terms, stronglyNegated)
        Literal.__init__(self, negatedAsFailure)
        
    def __str__(self):
        return Literal.__str__(self) + ClassicalAtom.__str__(self)
