'''
Created on Apr 10, 2018

@author: jessica
'''


class Predicate(object):

    __names2idx = {}
    __idx2names = []

    def __init__(self, name, arity):
        if (name,arity) in Predicate.__names2idx:
            self.__idx = Predicate.__names2idx[(name,arity)]
        else:
            Predicate.__names2idx[(name,arity)] = len(Predicate.__idx2names)
            self.__idx = len(Predicate.__idx2names)
            Predicate.__idx2names.append((name,arity))

    def getIndex(self):
        return self.__idx

    def getName(self):
        assert self.__idx in range(len(Predicate.__idx2names))
        pred = Predicate.__idx2names[self.__idx]
        return pred[0]

    def getArity(self):
        assert self.__idx in range(len(Predicate.__idx2names))
        pred = Predicate.__idx2names[self.__idx]
        return pred[1]

    def isNegative(self):
        assert self.__idx in range(len(Predicate.__idx2names))
        pred = Predicate.__idx2names[self.__idx]
        assert len(pred[0]) > 0
        if pred[0][0] == '-':
            return True
        else:
            return False

    @classmethod
    def getNameFromIdx(cls,idx):
        assert idx in range(len(cls.__idx2names))
        pred = cls.__idx2names[idx]
        return pred[0]
    
    @classmethod
    def getArityFromIdx(cls,idx):
        assert idx in range(len(cls.__idx2names))
        pred = cls.__idx2names[idx]
        return pred[1]

    def __str__(self):
        return self.getName()

    
