'''
Created on Apr 10, 2018

@author: jessica
'''
from datalog.Term import Variable, FunctionalTerm
from datalog.Literal import NafLiteral

class Rule(object):
    
    def __init__(self, head = None, body = None):
        self.predicates = []
        if head == None:
            self.__head = []
        else:
            self.__head = head
        if body == None:
            self.__body = []
        else:
            self.__body = body

    def getPredicates(self):
        for i in self.__head:
            if i.getPredicate() not in self.predicates:
                self.predicates.append(i.getPredicate())
        for j in self.__body:
            if j.getPredicate() not in self.predicates:
                self.predicates.append(j.getPredicate())
        return self.predicates

    def getHead(self):
        return self.__head

    def getBody(self):
        return self.__body

    def setHead(self, value):
        self.__head = value

    def setBody(self, value):
        self.__body = value
    
    def addInHead(self, atom):
        self.__head.append(atom)
        
    def getFromHead(self, i):
        if i < len(self.__head):
            return self.__head[i]
        return 0
 
    def addInBody(self, literal):
        self.__body.append(literal)
    
    def getFromBody(self, i):
        if i < len(self.__body):
            return self.__body[i]
        return 0
    
    def isSafe(self):
        safeVariables = set()
        for literal in self.__body:
            if isinstance(literal, NafLiteral) and not literal.getNegatedAsFailure():
                for var in literal.getVariables():
                    safeVariables.add(var)

        for literal in self.__body:
            for term in literal.getVariables():
                if not term in safeVariables:
                    #print(isinstance(term, Variable))
                    return False
                
        for atom in self.__head:
            for term in atom.getVariables():
                if not term in safeVariables:
                    return False
        return True
    
    def __str__(self):
        s = ""
        if len (self.__head):
            for atom in self.__head:
                s += atom.__str__()
                s += "|"
            s = s[:-1]
        if len (self.__body):
            s += ":-"
            for literal in self.__body:
                s += literal.__str__()
                s += ","
            s = s[:-1]
        s += "."
        return s
