from Facade import Facade
from parser.Option import Option
import os
import re

def bigasp(rules,facts,outputPredicates,db,server,username,password):
    facade = Facade()
    return facade.solve(rules,facts,outputPredicates,db,server,username,password)

if __name__ == '__main__':

    Option.getInstance().setTesting(True)
    fail = open("FailTests.txt", "w")
    success = open("SuccessTests2.txt", "w")
    path, dirs, files = next(os.walk("dlvtests"))
    for i in range(len(files)):
        # Leggo l'i-esimo file dalla cartella, ogni file corrisponde a un programma
        f = open("dlvtests/test"+str(i+1), "r")
        program = f.read()
        print("dlvtests/test"+str(i+1))
        f.close()

        # Eseguo il programma con idlv
        output = os.popen("./idlv --t --silent "+"dlvtests/test"+str(i+1))
        dlvResults = []
        rAUX = re.compile('^aux\w+(\([\w,]*\w\))*\.')
        for y in output:
            y = y[:-1]
            if not rAUX.match(y):
                dlvResults.append(y)
        dlvResults = list(dict.fromkeys(dlvResults))
        dlvResults.sort()

        # Eseguo il programma con bigasp
        '''POSTGRES'''
        #bigAspResults = bigasp(program, "", "", "database", "localhost", "domenico97", "12345")
        '''HIVE'''
        bigAspResults = bigasp(program, "", "", "bigdlv", "localhost:10000", "hiveuser", "hivepassword")

        # Comparo i risultati
        if bigAspResults == dlvResults:
            success.write("test" + str(i + 1) + "\n")
            print("OK\n")
        else:
            if bigAspResults == "The system can't execute this program.":
                fail.write("test"+str(i+1)+": The system can't execute this program.\n")
            else:
                fail.write("test" + str(i + 1) + ": Different results.\n")
                print(bigAspResults)
                print(dlvResults)
            print("NO\n")

    success.close()
    fail.close()
