'''
Created on Apr 9, 2018

@author: jessica
'''
from parser import yacc
from parser.ErrorMessage import ErrorMessage

class Director(object):

    def __init__(self):
        self.__inputBuilder = None
        self.__outputBuilder = None
        self.__errorInParsing = False

    def getInputBuilder(self):
        return self.__inputBuilder

    def getOutputBuilder(self):
        return self.__outputBuilder

    def configureInputBuilder(self, inputBuilder):
        self.__inputBuilder = inputBuilder

    def configureOutputBuilder(self, outputBuilder):
        self.__outputBuilder = outputBuilder
        
    def parseLine(self, line):
        if not line:
            return
        if yacc.yyparse(self,line):
            self.__errorInParsing = True
        return self.__errorInParsing
            
    def parseLines(self, lines):
        for line in lines:
            if not self.__errorInParsing:
                self.parseLine(line)
        return self.__errorInParsing
     
    def parseFile(self, f):
        fileObj = open(f,'r')
        self.parseLines(fileObj)
        fileObj.close()
        return self.__errorInParsing
     
    def parseFiles(self, files):
        for f in files:
            if not self.__errorInParsing:
                self.parseFile(f)
        return self.__errorInParsing
     
    def parseRawInput(self):
        while True:
            try:
                line = raw_input()
            except EOFError:
                ErrorMessage.onError("Aborting due to parser errors.")
                break
            self.parseLine(line)
            if self.__errorInParsing:
                break
        return self.__errorInParsing
         
    def onError(self, message):
        self.__errorInParsing = True
        print(message)
        

