'''
Created on Apr 9, 2018

@author: jessica
'''
import ply.lex as lex

reserved = {'not' : 'NAF'}

tokens = [
    'NUMBER',
    'IDENTIFIER',
    'VARIABLE',
    'STRING',
    'COMMA',
    'ANON_VAR',
    'CONS',
    'PARAM_OPEN',
    'PARAM_CLOSE',
    'DOT',
    'NEG',
    'EQUAL',
    'UNEQUAL',
    'LESS',
    'GREATER',
    'LESS_OR_EQ',
    'GREATER_OR_EQ'
] + list(reserved.values())

t_ignore            = '[ \t\n]+'
t_ignore_COMMENT    = r'\%.*'
t_NUMBER            = r'[0-9]+'
t_VARIABLE          = r'[A-Z][A-Za-z_0-9]*'
t_STRING            = r'"[^\"]*"'
t_COMMA             = r','
t_ANON_VAR          = r'_'
t_CONS              = r':-'
t_PARAM_OPEN        = r'\('
t_PARAM_CLOSE       = r'\)'
t_DOT               = r'\.'
t_NEG               = r'-'
t_EQUAL             = r'='
t_UNEQUAL           = r'!=|<>'
t_LESS              = r'<'
t_GREATER           = r'>'
t_LESS_OR_EQ        = r'<='
t_GREATER_OR_EQ     = r'>='

def t_IDENTIFIER(t):
    r'[a-z][a-zA-Z_0-9]*'
    # Check for reserved words
    t.type = reserved.get(t.value, 'IDENTIFIER')
    return t

def t_error(t):
    #print("Illegal character '%s'" % t.value[0])
    t.lexer.skip(1)

lexer = lex.lex()

# if __name__ == '__main__':
#     data = """p(X) :- q(Y), not Z(X,Y).
#             p(X) :- q_1(X), -Z_2().
#             """
#     
#     lexer = lex.lex()
#     lexer.input(data)
# 
#     # Tokenize
#     while True:
#         tok = lexer.token()
#         if not tok: break      # No more input
#         print tok

