from abc import ABC
from abc import abstractmethod

class SourceManager(ABC):
    
    def __init__(self):
        self.__recLevelColumnName = "reclevel"
        self.__timeStamp = "executiontime"

    def getRecursionLevelColumnName(self):
        return self.__recLevelColumnName

    def getTimeStampColumnName(self):
        return self.__timeStamp

    @abstractmethod
    def executeStatement(self,statement,params=None):
        pass
    
    @abstractmethod
    def getTableSchema(self,pred): #if pred does not match any table, create a matching table
        pass
    
    @abstractmethod
    def commit(self):
        pass
